/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package ZEN_IDL.be;

import java.io.*;
import java.io.PrintWriter;
import java.util.*;
import ZEN_IDL.ast.*;
import ZEN_IDL.be.symbolTableUtils.*;
import ZEN_IDL.be.helperUtils.*;

/*********************************************************
* A class for mapping between typedefs and real types
*
* @author Olav Haugan
*
* 14.10.01
*********************************************************/
public class MQCTypedefMapping
{
	private static java.util.HashMap types = new java.util.HashMap(4);
	
	/*********************************************************
	* Adds a mapping to the list of mappings
	* 
	* @param String The real type
	*        
	* @param String The name of the type
	*
	*********************************************************/
	public static void add(String name, String realType)
	{
		types.put(name, realType);
	}

	/*********************************************************
	* Gets a mapping from the list of mappings
	* 
	* @param String The name of the type
	*
	* @return String The real type
	*
	*********************************************************/
	public static String get(String name)
	{
		String type = (String) types.get(name);
		if(type == null)
			return name;
		else
			return type;
	}
}
