/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */


package ZEN_IDL.be;

import java.util.*;

public class TypedefDeclarator
{
    private String name;
    private String arrayBracketsAndSizes;
    private int dimensions;
    //Simple Constructors
    public TypedefDeclarator( String name )
    {
        this.name = name;
        this.arrayBracketsAndSizes = "";
        this.dimensions = 0;
    } 
    public TypedefDeclarator( String name, String arrayBracketsAndSizes, int dimensions )
    {
        this.name = name;
        this.arrayBracketsAndSizes = arrayBracketsAndSizes;
        this.dimensions = dimensions;
    }  
    public boolean isArray()
    {
        if( arrayBracketsAndSizes.equals("") )
	    return false;
	else
	    return true;
    }
    public int[] getArraySizes()
    {
       	if( arrayBracketsAndSizes.equals("") )
	    return null;
	int [] arraySizes = new int[dimensions];
	try
	{
	    StringTokenizer st = new StringTokenizer( arrayBracketsAndSizes, " []" );
	    for( int i = 0; i < dimensions ; i++ )
	    {
	        arraySizes[i] = Integer.parseInt( st.nextToken() );
	    }
	}
	catch( Exception e )
	{
	    System.out.println("Error getting array size");
	    return null;
	}
	return arraySizes;
    }	
    public String getEmptyBrackets()
    {
    	String arrayBrackets = "";
	for( int i = 0; i < dimensions; i++ )
		arrayBrackets += "[]";
	return arrayBrackets;
    }
    //Print Functions
    public String printAsDeclaration()
    {
        return name + arrayBracketsAndSizes;
    }
    public String printAsParameter()
    {
        String arrayBrackets = "";
        for( int i = 0; i < dimensions; i++ )
            arrayBrackets += "[]";
        return name + arrayBrackets;
    }
    public String printAsAssignment()
    {
        return name;
    }
    public String toString()
    {
        return name;
    }
}
