/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

import banker.*;
import java.util.HashMap;

public class bankImpl extends bankPOA
{
   protected HashMap m_accounts;

   public bankImpl()
   {
      m_accounts=new HashMap();
   }

   public short createAccount(float initialValue)
   {
      Account account = new Account(initialValue);
      Integer acctNum = new Integer(account.getAccountNumber());
      System.out.println("$" + initialValue + " used to start account #" + acctNum + ".");
      m_accounts.put(acctNum, account);
      return account.getAccountNumber();
   }

   public boolean deposit(short accountNumber, float amount)
   {
      Integer acctNum = new Integer(accountNumber);
      Account account=(Account)m_accounts.get(acctNum);
      if(account!=null)
      {
         account.deposit(amount);
         System.out.println("Deposit of $" + amount + " to account #" + acctNum + ".  New balance: $" + this.checkBalance(accountNumber) + ".");
         return true;
      }
      else
      {
         return false;
      }
   }

   public boolean withdraw(short accountNumber, float amount)
   {
      Integer acctNum=new Integer(accountNumber);
      Account account=(Account)m_accounts.get(acctNum);
      if(account!=null)
      {
         account.withdraw(amount);
         System.out.println("Withdrawl of $" + amount + " from account #" + acctNum + ".  New balance: $" + this.checkBalance(accountNumber) + ".");
         return true;
      }
      else
      {
         return false;
      }
   }

   public float checkBalance(short accountNumber)
   {
      Integer acctNum=new Integer(accountNumber);
      Account account=(Account)m_accounts.get(acctNum);
      if(account!=null)
      {
         return account.getBalance();
      }
      else
      {
         return 0;
      }
   }
};

class Account
{
   protected static short s_nextAccountNumber = 0;
   protected float m_balance;
   protected short m_accountNumber;
   public Account(float initialBalance)
   {
      this.m_balance = initialBalance;
      this.m_accountNumber = s_nextAccountNumber++;
   }
   public short getAccountNumber()
   {
      return this.m_accountNumber;
   }
   public float getBalance()
   {
      return this.m_balance;
   }
   public void deposit(float amount)
   {
      this.m_balance += amount;
   }
   public void withdraw(float amount)
   {
      this.m_balance -= amount;
   }
}
