/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.ior;

/**
* The UDPxIIOP profile class.
*
* @author Eivind Naess
*/
public class UIOPProfile extends TaggedProfile
{

  /**
   * Constructor for the UIOPProfile
   */
   public UIOPProfile()
   {
      super(TaggedProfile.UIOP);
   }

   /** 
    * Encodes a corbaloc from the current profile
	* @param corbalocStr A String buffer
	* @return An Encoded Corbaloc String
	*/ 
   public String encodeCorbalocProfile(String corbalocStr)
   {
      corbalocStr = super.encodeCorbalocProfile ("uiop");
      return corbalocStr;
   }

   /**
    * Overides Clone in Object
	* @return A copy of itself
	*/
   public Object clone ()
   {
      UIOPProfile profile = new UIOPProfile();
      profile.objectKey = new byte[objectKey.length];
      System.arraycopy(objectKey, 0, profile.objectKey, 0, objectKey.length);
      profile.seqLen = seqLen;
      profile.major = major;
      profile.minor = minor;
      profile.host = host;
      profile.port = port;
      profile.bigEndian = bigEndian;
      return profile;
   }
}
