/*
 * Copyright (c) 2003 David E. Bakken, his research students, and Washington State University.
 * Please see the file LICENSE.pdf for more details on terms of use.
 */

package mqc.transports;

/**
* Base transport handler class
* 
* @author Olav Haugan
*
* 14.10.01
*/
public abstract class S_TransportHandler
{
   protected CDRInputStream m_in;
   protected CDROutputStream m_out;

   /**
   * Sends a message
   *
   * @param byte[] The buffer to send
   * @param int The number of bytes to transmit
   * @return boolean true if data is sent successfully, false otherwise
   */
   public abstract boolean send(byte[] buffer, int length);

}
